;**************************************************************************
;*
;* FILE  decode.asm
;* Copyright (c) 2007 Daniel Kahlin <daniel@kahlin.net>
;* Written by Daniel Kahlin <daniel@kahlin.net>
;* $Id: decode.asm,v 1.50 2007-12-07 18:52:58 tlr Exp $
;*
;* DESCRIPTION
;*   Statistical Cracker
;*
;******
	processor	6502

	include	"macros.i"

COL_BORDER	equ	11
COL_BACKGROUND	equ	0
COL_TEXT	equ	5
COL_TEXTKEY	equ	13
COL_UNPRINTABLE	equ	10

MAX_KEY		equ	64
NUM_KEYS	equ	3
	
INTRO_START	equ	$2000
		
	seg.u	zp
;**************************************************************************
;*
;* SECTION  zero page
;*
;******
	org	$a3
iptr_zp:
	ds.w	1
pptr_zp:
	ds.w	1
len_zp:
	ds.b	1

	org	$b0
dividend_zp:
	ds.b	2
divisor_zp:
	ds.b	1
remainder_zp:
	ds.b	2

	org	$f7
ptr_zp:
	ds.w	1
dptr_zp:
	ds.w	1
eptr_zp:
	ds.w	1
tmp_zp:
	ds.b	1

	seg	code
	org	$0801
;**************************************************************************
;*
;* Basic line!
;*
;******
StartOfFile:
	dc.w	EndLine
	dc.w	0
	dc.b	$9e,"2069 /T.L.R/",0
;	        0 SYS2069 /T.L.R/
EndLine:
	dc.w	0
	
;**************************************************************************
;*
;* SysAddress... When run we will enter here!
;*
;******
SysAddress:
sa_sm1:
	jsr	onetime_init

; $ff5b-ish, without the ugly blue flickering.
	sei
wv_lp1:
	lda	$d011
	bpl	wv_lp1
wv_lp2:
	lda	$d011
	bmi	wv_lp2
	jsr	$e5a0
	lda	#COL_BORDER
	sta	$d020
	if	COL_BORDER!=$0b
	lda	#$0b
	endif
	sta	$d011
	lda	#COL_BACKGROUND
	sta	$d021
	jsr	$e51b
; done, screen blank
	cli

sa_start:
	lda	#0
	sta	$c6

	lda	#COL_TEXT
	sta	646
	ldx	#<greet_msg
	ldy	#>greet_msg
	jsr	print

; enable screen.
	lda	#$1b
	sta	$d011

sa_lp1:
	jsr	load_file
	bcs	sa_lp1
	jsr	print_range
	jsr	print_comma
	jsr	print_space

	jsr	identify
	bcs	sa_lp1

; run the identified decoder
	ldy	#0	
	lda	(iptr_zp),y
	sta	sa_sm2+1
	iny
	lda	(iptr_zp),y
	sta	sa_sm2+2
sa_sm2:
	jsr	sa_sm2

	jsr	print_cr		
	jsr	print_cr		
	jsr	print_range
	ldx	#<decoded_msg
	ldy	#>decoded_msg
	jsr	print

; target menu
sa_lp2:
	ldx	#<donemenu_msg
	ldy	#>donemenu_msg
	jsr	print
sa_lp3:
	jsr	$ffe4
	beq	sa_lp3

	cmp	#"S"
	beq	sa_save
	cmp	#"R"
	beq	sa_run
	cmp	#"C"
	beq	sa_candidates
	cmp	#"A"
	beq	sa_start
	cmp	#"X"
	beq	sa_exit
	jmp	sa_lp3
	
sa_save:
	jsr	print_cr
	jsr	save_file
	jmp	sa_lp2

sa_run:
	jsr	print_cr
	jsr	run_buffer
	jmp	sa_lp2

sa_candidates:
	jsr	print_cr
	jsr	print_candidates
	jmp	sa_lp2

sa_exit:
	jsr	print_cr
	jsr	print_cr
	jmp	$a474
	
greet_msg:
	dc.b	147
	dc.b	"DE-CODER / TLR'07!",13
	dc.b	"STATISTICAL CRACKER",13
	dc.b	"(MAX 230 BLOCKS)",13,0
decoded_msg:
	dc.b	", DECODED",13,0
donemenu_msg:
	dc.b	13
	dc.b	18,"S",146,"AVE/"
	dc.b	18,"R",146,"UN/"
	dc.b	18,"C",146,"ANDIDATES/"
	dc.b	18,"A",146,"NOTHER/"
	dc.b	"E",18,"X",146,"IT? "
	dc.b	0

;**************************************************************************
;*
;* NAME  onetime_init
;*
;* DESCRIPTION
;*   initialize, present intro screen
;*
;******
onetime_init:
	lda	#$2c
	sta	sa_sm1

	jsr	INTRO_START

; force disk access
	lda	#8
	cmp	$ba
	bcc	oti_skp1
	sta	$ba
oti_skp1:
	
	rts
	

;**************************************************************************
;*
;* NAME  run_buffer
;*
;* DESCRIPTION
;*   set all ram, set $01=$37
;*
;******
run_buffer:
	ldx	start_addr
	ldy	start_addr+1
	jsr	set_ptr

	lda	start_addr
	sta	dptr_zp
	lda	start_addr+1
	sta	dptr_zp+1

	lda	end_addr
	sta	$ae
	sta	$2d
	lda	end_addr+1
	sta	$ae
	sta	$2e
	sec
	sbc	start_addr+1
	sta	len_zp		; len_zp=>end_addr->start_addr+1
	inc	len_zp

	sei
	lda	#$34
	sta	$01
	ldx	#RUNNER_LEN
rb_lp1:
	lda	runner_st-1,x
	sta	runner-1,x
	dex
	bne	rb_lp1
	jmp	runner
runner_st:
	rorg	$0110
runner:
	ldy	#0
rn_lp1:
	lda	(ptr_zp),y
	sta	(dptr_zp),y
	iny
	bne	rn_lp1
	inc	ptr_zp+1
	inc	dptr_zp+1
	dec	len_zp
	bne	rn_lp1
	lda	#$37
	sta	$01
	cli
	jsr	$a659
	jmp	$a7ae
	rend
RUNNER_LEN	equ	.-runner_st

	
;**************************************************************************
;*
;* NAME  mem_ram, mem_normal
;*
;* DESCRIPTION
;*   set all ram, set $01=$37
;*
;******
mem_ram:
	php
	sei
	pla
	sta	old_sr
	lda	$01
	sta	old_mem
	lda	#$34
	sta	$01
	rts
mem_normal:
	lda	old_mem
	sta	$01
	lda	old_sr
	pha
	plp
	rts
old_mem:
	ds.b	1
old_sr:
	ds.b	1

;**************************************************************************
;*
;* NAME  print_range
;*
;* DESCRIPTION
;*   print range of buffer
;*   
;******
print_range:
	jsr	print_dollar
	lda	start_addr+1
	jsr	print_hex
	lda	start_addr
	jsr	print_hex
	lda	#"-"
	jsr	$ffd2
	jsr	print_dollar
	lda	end_addr+1
	jsr	print_hex
	lda	end_addr
	jsr	print_hex
	rts

;**************************************************************************
;*
;* NAME  print_hex
;*
;* DESCRIPTION
;*   output hex byte.
;*   
;******
print_hex:
	pha
	lsr
	lsr
	lsr
	lsr
	jsr	ph_skp1
	pla
	and	#$0f
ph_skp1:
	clc
	adc	#"0"
	cmp	#"9"+1
	bcc	ph_skp2
	adc	#"A"-("9"+1)-1
ph_skp2:
	jmp	$ffd2

;**************************************************************************
;*
;* NAME  print_cr
;*
;******
print_dollar:
	lda	#"$"
	dc.b	$2c
print_comma:
	lda	#","
	dc.b	$2c
print_space:
	lda	#" "
	dc.b	$2c
print_cr:
	lda	#13
	jmp	$ffd2
	
;**************************************************************************
;*
;* NAME  print
;*
;******
print:
	stx	pptr_zp
	sty	pptr_zp+1
	ldy	#0
prt_lp1:
	lda	(pptr_zp),y
	beq	prt_ex1
	jsr	$ffd2
	iny
	bne	prt_lp1
	inc	pptr_zp+1
	bne	prt_lp1
prt_ex1:
	rts
	
;**************************************************************************
;*
;* NAME  input_filename
;*
;* DESCRIPTION
;*   input filename and set up.
;*
;******
input_filename:
	ldy	#0
if_lp1:
	jsr	$ffcf
	cmp	#13
	beq	if_ex1
	sta	filename,y
	iny
	cpy	#filename_end-filename
	bne	if_lp1
if_ex1:
	tya
	ldx	#<filename
	ldy	#>filename
	jmp	$ffbd
;	rts

;**************************************************************************
;*
;* NAME  show_dir
;*
;* DESCRIPTION
;*   show directory listing
;*
;******
show_dir:

; initialize and open
	lda	#1
	ldx	#<dir_msg
	ldy	#>dir_msg
	jsr	$ffbd	;SETNAM
	lda	#1
	ldx	$ba
	ldy	#$60
	jsr	$ffba	;SETLFS
	jsr	$ffc0	;OPEN
	lda	$90
	and	#%10000011
	bne	sdr_fl1
	lda	$ba
	jsr	$ffb4	;TALK
	lda	$b9
	jsr	$ff96	;TKSA

	ldy	#$03
sdr_lp1:
	sty	sdr_tmp
sdr_lp2:
	jsr	$ffa5	;ACPTR
	sta	sdr_linenum
	jsr	$ffa5	;ACPTR
	sta	sdr_linenum+1
	ldy	$90
	bne	sdr_ex1
	dec	sdr_tmp
	bne	sdr_lp2
	jsr	sdr_outputdecimal
	lda	#" "
	jsr	$ffd2	;CHROUT
sdr_lp3:
	jsr	$ffa5	;ACPTR
	ldx	$90
	bne	sdr_ex1
	cmp	#0
	beq	sdr_skp1
	jsr	$ffd2	;CHROUT
	jmp	sdr_lp3
sdr_skp1:
	lda	#13
	jsr	$ffd2	;CHROUT
	ldy	#$02
sdr_lp4:
	jsr	$ffe1	;STOP
	bne	sdr_lp1

sdr_ex1:

;*
;* exit, clean up
;*
	jsr	$ffab	;UNTLK
	lda	#1
	jsr	$ffc3	;CLOSE
sdr_fl1:
	jsr	$ffe7	;CLALL
	clc
	rts

sdr_linenum:
	dc.w	0
sdr_tmp:
	dc.b	0

sdr_outputdecimal:
	ldx	sdr_linenum
	lda	sdr_linenum+1
	jmp	$bdcd	;Output decimal number

dir_msg:
	dc.b	"$"

;**************************************************************************
;*
;* NAME  get_name_dir
;*
;* DESCRIPTION
;*   Get filename, and allow for directory by $.
;*
;******
get_name_dir:
	stx	gnd_sm1+1
	sty	gnd_sm2+1
gnd_lp1:
gnd_sm1:
	ldx	#0
gnd_sm2:
	ldy	#0
	jsr	print
	jsr	input_filename
	jsr	print_cr

;check length, exit if = 0
	lda	$b7
	beq	gnd_fl1

;check if directory
	ldy	#0
	lda	($bb),y
	cmp	#"$"
	bne	gnd_ex1

	jsr	print_cr
	jsr	show_dir
	jmp	gnd_lp1
gnd_ex1:
	clc
	rts
gnd_fl1:
	sec
	rts


;**************************************************************************
;*
;* NAME  load_file
;*
;* DESCRIPTION
;*   load file into buffer and calculate offset.
;*
;******
lf_ex1:
	rts
load_file:

	ldx	#<loadname_msg
	ldy	#>loadname_msg
	jsr	get_name_dir
	bcs	lf_ex1
	
; use last accessed device
	lda	#1
	ldx	$ba
	ldy	#0		; read
	jsr	$ffba

; Print "SEARCHING FOR <name>"  (skipping the direct mode check at $f5af)
 	jsr	$f5b3		

; open the file.
	jsr	$ffc0
	lda	$90
	and	#%10000011
	bne	lf_fl3

; make it default input
	ldx	#1
	jsr	$ffc6

; load address
	jsr	$ffe4
	sta	start_addr
	jsr	$ffe4
	sta	start_addr+1

; calculate offset and set up ptr_zp to program buffer
	lda	#<program_buffer
	sta	ptr_zp
	sec
	sbc	start_addr
	sta	offset
	lda	#>program_buffer
	sta	ptr_zp+1
	sbc	start_addr+1
	sta	offset+1
	
				
; Print "LOADING"  (skipping the direct mode check at $f5d2)
	ldy	#$49
 	jsr	$f12f

; load data
	ldy	#0
lf_lp1:
	jsr	$ffe4
	sei
	ldx	#$34
	stx	$01
	sta	(ptr_zp),y
	ldx	#$37
	stx	$01
	cli

	lda	$90		; check status, exit if fail
	and	#%10000011
	bne	lf_fl1

	inc	ptr_zp
	bne	lf_skp1
	inc	ptr_zp+1
lf_skp1:
	
; check for end of file
	bit	$90
	bvc	lf_lp1		;if not finished... loop!

	lda	#0
lf_fl1:	
	php
; restore default input
	jsr	$ffcc
; and close file
	lda	#1
	jsr	$ffc3

; fix up the end pointer
	jsr	get_ptr
	stx	end_addr
	sty	end_addr+1

; pop the status and check
	plp
	bne	lf_fl2

	ldx	#<dok_msg
	ldy	#>dok_msg
	jsr	print
	clc
	rts
	
lf_fl3:
	jsr	$ffe7
lf_fl2:
	ldx	#<dfailed_msg
	ldy	#>dfailed_msg
	jsr	print
	sec
	rts

loadname_msg:
	dc.b	13,"LOADNAME ($): ",0
savename_msg:
	dc.b	13,"SAVENAME ($): ",0
dok_msg:
	dc.b	13,"OK",13,0
dfailed_msg:
	dc.b	13,"FAILED!",13,0
	
;**************************************************************************
;*
;* NAME  save_file
;*
;* DESCRIPTION
;*   save file from buffer using offset.
;*
;******
sf_ex1:
	rts
save_file:

	ldx	#<savename_msg
	ldy	#>savename_msg
	jsr	get_name_dir
	bcs	sf_ex1

	ldx	start_addr
	ldy	start_addr+1
	jsr	set_ptr
	ldx	end_addr
	ldy	end_addr+1
	jsr	set_eptr

; Print "SAVING <name>"  (skipping the direct mode check at $f68f)
 	jsr	$f693

; use last accessed device
	lda	#1
	ldx	$ba
	ldy	#1
	jsr	$ffba

	jsr	$ffc0
	lda	$90
	and	#%10000011
	bne	sf_fl3

; make it default output
	ldx	#1
	jsr	$ffc9

; the load address
 	lda	start_addr
	jsr	$ffd2
 	lda	start_addr+1
	jsr	$ffd2

	ldy	#0
sf_lp1:
	sei
	ldx	#$34
	stx	$01
	lda	(ptr_zp),y
	ldx	#$37
	stx	$01
	cli
	jsr	$ffd2

	lda	$90		; check status, exit if fail
	and	#%10000011
	bne	sf_fl1	

	inc	ptr_zp
	bne	sf_skp1
	inc	ptr_zp+1
sf_skp1:
	lda	ptr_zp
	cmp	eptr_zp
	lda	ptr_zp+1
	sbc	eptr_zp+1
	bcc	sf_lp1
	
	lda	#0
sf_fl1:
	php
; restore default output
	jsr	$ffcc
; and close file
	lda	#1
	jsr	$ffc3

; pop the status and check
	plp
	bne	sf_fl2

	ldx	#<dok_msg
	ldy	#>dok_msg
	jsr	print
	clc
	rts

sf_fl3:
	jsr	$ffe7
sf_fl2:
	ldx	#<dfailed_msg
	ldy	#>dfailed_msg
	jsr	print
	sec
	rts

;**************************************************************************
;*
;* NAME  divide
;*
;* DESCRIPTION
;*   16 bit dividend / 8 bit divisor
;*   dividend[0-2]=dividend[0-2]/divisor
;*   remainder=dividend[0-2]%divisor
;*   IN: X/Y=dividend, Acc=divisor
;*   OUT: X/Y=factor, Acc=remainder				
;*   carry set = divide by zero!
;*
;******
divide:
;*
;* Check for zero divisor
;*
	sta	divisor_zp
	cmp	#0
	sec
	beq	div_fl1		;exit with carry=1 if zero

	stx	dividend_zp
	sty	dividend_zp+1
;*
;* setup remainder
;*
	lda	#0
	sta	remainder_zp
	sta	remainder_zp+1

	ldx	#16+1
	clc
	bcc	div_skp1	;ALWAYS!

;*
;* divide loop
;*
div_lp1:
	rol	remainder_zp
	rol	remainder_zp+1

;*
;* Does it fit?
;*
	sec
	lda	remainder_zp
	sbc	divisor_zp
	lda	remainder_zp+1
	sbc	#0
	bcc	div_skp1	;no... shift in 

;* yes... subtract
	sec
	lda	remainder_zp
	sbc	divisor_zp
	sta	remainder_zp
	bcs	div_skp1
	dec	remainder_zp+1
	sec
div_skp1:
	rol	dividend_zp
	rol	dividend_zp+1
	dex
	bne	div_lp1
	lda	remainder_zp
	ldx	dividend_zp
	ldy	dividend_zp+1
	clc
div_fl1:
	rts

;**************************************************************************
;*
;* NAME  set_ptr, set_eptr, set_dptr
;*
;******
set_ptr:
	pha
	txa
	ldx	#ptr_zp
	bne	sp_common
set_eptr:
	pha
	txa
	ldx	#eptr_zp
	bne	sp_common
set_dptr:
	pha
	txa
	ldx	#dptr_zp
sp_common:
	pha
	clc
	adc	offset
	sta	$00,x
	tya
	adc	offset+1
	sta	$01,x
	pla
	tax
	pla
	rts

;**************************************************************************
;*
;* NAME  get_ptr, get_eptr, get_dptr
;*
;******
get_ptr:
	ldy	#ptr_zp
	dc.b	$2c
get_eptr:
	ldy	#eptr_zp
	dc.b	$2c
get_dptr:
	ldy	#dptr_zp
gp_common:
	pha
	lda	$00,y
	sec
	sbc	offset
	tax
	lda	$01,y
	sbc	offset+1
	tay
	pla
	rts

;**************************************************************************
;*
;* NAME  transfer
;*
;* DESCRIPTION
;*   transfer memory (ptr_zp->dptr_zp)
;*
;******
transfer:
	jsr	mem_ram
	ldy	#0
tr_lp1:
	lda	(ptr_zp),y
	sta	(dptr_zp),y
	inc	ptr_zp
	bne	tr_skp1
	inc	ptr_zp+1
tr_skp1:
	inc	dptr_zp
	bne	tr_skp2
	inc	dptr_zp+1
tr_skp2:
	lda	ptr_zp
	cmp	eptr_zp
	lda	ptr_zp+1
	sbc	eptr_zp+1
	bcc	tr_lp1
	jmp	mem_normal
;	rts

;**************************************************************************
;*
;* NAME  autocorr, autocorr_init, find_max
;*
;* DESCRIPTION
;*   calculate autocorrelation (ptr_zp to eptr_zp)
;*
;******
autocorr_init:
	sta	max_n
	stx	ac_sm1+1
	ldx	#MAX_KEY-1
	lda	#0
	sta	max_ind
aci_lp1:
	sta	auto_cnt,x
	dex
	bpl	aci_lp1
	rts
;***
autocorr:
; max room for max_n at the end of the range
	lda	eptr_zp
	sec
	sbc	max_n
	sta	eptr_zp
	bcs	ac_skp1
	dec	eptr_zp+1
ac_skp1:

	jsr	mem_ram
; perform the actual autocorrelation
ac_lp1:
	ldy	max_n
	dey
	sty	cur_n
ac_lp2:
	ldy	#0
	lda	(ptr_zp),y
;optional transformation here
	clc
ac_sm1:
	adc	#1
; end transformation
	ldy	cur_n
	cmp	(ptr_zp),y
	bne	ac_skp2
	tya
	tax
	inc	auto_cnt,x
	bne	ac_skp2
	dec	auto_cnt,x	;ceil at $ff
ac_skp2:	
	dec	cur_n
	bne	ac_lp2
	inc	ptr_zp
	bne	ac_skp3
	inc	ptr_zp+1
ac_skp3:
	lda	ptr_zp
	cmp	eptr_zp
	lda	ptr_zp+1
	sbc	eptr_zp+1
	bcc	ac_lp1

	jsr	mem_normal
	rts
;***
find_max:
	ldx	#MAX_KEY-1
	lda	#0
	sta	max_ind
fm_lp1:
	cmp	auto_cnt,x
	bcs	fm_skp1
	lda	auto_cnt,x
	stx	max_ind
fm_skp1:
	dex
	bpl	fm_lp1
	lda	max_ind
	rts

;**************************************************************************
;*
;* NAME  perform_autocorr, perform_autocorr2
;*   
;* DESCRIPTION
;*   Autocorrelate $0000 to $0200 and -$0200 to -$0000 to find key length
;*   in: Acc=max_key_len
;*
;******
perform_autocorr2:
	ldx	#1
	dc.b	$2c
perform_autocorr:
	ldx	#0
pa_common:
	jsr	autocorr_init

	ldx	#<auto_msg
	ldy	#>auto_msg
	jsr	print

; start_addr to start_addr+$0200
	ldx	start_addr
	ldy	start_addr+1
	jsr	set_ptr
	iny
	iny
	jsr	set_eptr
	jsr	autocorr

; end_addr-$0200 to end_addr
	ldx	end_addr
	ldy	end_addr+1
	jsr	set_eptr
	dey
	dey
	jsr	set_ptr	
	jsr	autocorr
	jsr	find_max
	cli
;Acc=key_len
	jmp	print_keylen
;	rts

auto_msg:
	dc.b	13,"AUTOCORRELATING...",0

;**************************************************************************
;*
;* NAME  xorstat, xorstat2, xorstat_init
;*
;* DESCRIPTION
;*   calculate xor statistics (ptr_zp to eptr_zp)
;*
;******
xorstat_init:
	sta	key_len
	sta	orig_key_len
	ldx	#KEY_BUF_LEN
	lda	#0
xsi_lp1:
	sta	key_buf-1,x
	dex
	bne	xsi_lp1
	rts
xorstat_clear:
	ldx	#0
	txa
xsc_lp1:
	sta	statbuf0,x
	sta	statbuf1,x
	sta	statbuf2,x
	inx
	bne	xsc_lp1
	rts
;***
xorstat:
	clc
	adc	ptr_zp
	sta	ptr_zp
	bcc	xs_skp1
	inc	ptr_zp+1
xs_skp1:

	jsr	mem_ram
xs_lp1:
	ldy	#0
	lda	(ptr_zp),y
	sta	xs_sm1+1
xs_lp2:
	tya
xs_sm1:
	eor	#$00		;self mod
	tax
	lda	stats0,y
	clc
	adc	statbuf0,x
	sta	statbuf0,x
	lda	stats1,y
	adc	statbuf1,x
	sta	statbuf1,x
	bcc	xs_skp2
	inc	statbuf2,x
xs_skp2:
	iny
	bne	xs_lp2
;increment address by key_len
	lda	ptr_zp
	clc
	adc	key_len
	sta	ptr_zp
	bcc	xs_skp3
	inc	ptr_zp+1
xs_skp3:
	lda	ptr_zp		; ptr_zp < eptr_zp
	cmp	eptr_zp
	lda	ptr_zp+1
	sbc	eptr_zp+1
	bcc	xs_lp1		; yes, continue

	jmp	mem_normal
;	rts
;***
xorstat2:
	clc
	adc	ptr_zp
	sta	ptr_zp
	bcc	xs2_skp1
	inc	ptr_zp+1
xs2_skp1:
; set difference
	stx	xs2_sm2+1
	
	jsr	mem_ram
xs2_lp1:
	ldy	#0
	lda	(ptr_zp),y
	sta	xs2_sm1+1
xs2_lp2:
	tya
xs2_sm1:
	eor	#$00		;self mod
	sec
xs2_sm2:
	sbc	#$00
	tax
	lda	stats0,y
	clc
	adc	statbuf0,x
	sta	statbuf0,x
	lda	stats1,y
	adc	statbuf1,x
	sta	statbuf1,x
	bcc	xs2_skp2
	inc	statbuf2,x
xs2_skp2:
	iny
	bne	xs2_lp2

;increment difference
	inc	xs2_sm2+1
;increment address by key_len
	lda	ptr_zp
	clc
	adc	key_len
	sta	ptr_zp
	bcc	xs2_skp3
	inc	ptr_zp+1
xs2_skp3:
	lda	ptr_zp		; ptr_zp < eptr_zp
	cmp	eptr_zp
	lda	ptr_zp+1
	sbc	eptr_zp+1
	bcc	xs2_lp1		; yes, continue

	jmp	mem_normal
;	rts
;***
find_key:
	ldx	#0
	stx	maxtmp
	stx	maxtmp+1
	stx	maxtmp+2
	ldy	#0
fk_lp1:
	lda	statbuf0,x
	cmp	maxtmp
	lda	statbuf1,x
	sbc	maxtmp+1
	lda	statbuf2,x
	sbc	maxtmp+2
	bcc	fk_skp1
	lda	statbuf0,x
	sta	maxtmp
	lda	statbuf1,x
	sta	maxtmp+1
	lda	statbuf2,x
	sta	maxtmp+2
	txa
	tay
fk_skp1:
	inx
	bne	fk_lp1

; clear out max, so a new search will give the next match
	lda	#0
	sta	statbuf0,y
	sta	statbuf1,y
	sta	statbuf2,y
	tya
	rts

;**************************************************************************
;*
;* NAME  perform_xorstat, perform_xorstat2
;*   
;* DESCRIPTION
;*   Analyze $0000 to $0200 and -$0200 to -$0000 to produce key.
;*   in: Acc=key_len, X=step
;*  
;******
cur_xorstat:
cxs_sm1:
	jmp	cur_xorstat

perform_xorstat2:
	ldy	#<xorstat2
	sty	cxs_sm1+1
	ldy	#>xorstat2
	sty	cxs_sm1+2
	ldx	#1
	bne	px_common
perform_xorstat:
	ldy	#<xorstat
	sty	cxs_sm1+1
	ldy	#>xorstat
	sty	cxs_sm1+2
	ldx	#0
px_common:
	jsr	xorstat_init

; calculate offset of the first occurance of the first digit in the upper
; block.
; calculate the number of cycles up to that occurance.
; tmp = (end_addr-$0200)-start_addr % key_len
	lda	end_addr
	sec
	sbc	start_addr
	tax
	lda	end_addr+1
	sbc	start_addr+1
	tay
	dey
	dey
	lda	key_len
	jsr	divide
	sta	up_offs
	stx	num_cycles

; offs = (key_len-tmp) % key_len
	cmp	#$00
	beq	px_skp1
	lda	key_len
	sec
	sbc	up_offs
	sta	up_offs
	inc	num_cycles
px_skp1:

; perform analysis, digit by digit.
	ldx	#<analyzing_msg
	ldy	#>analyzing_msg
	jsr	print

	lda	#0
	sta	key_offs
px_lp2:
	tax
	lda	#0
	jsr	$bdcd
	
	sei
	jsr	xorstat_clear

; start_addr to start_addr+$0200
	ldx	start_addr
	ldy	start_addr+1
	jsr	set_ptr
	iny
	iny
	jsr	set_eptr
	lda	key_offs
	ldx	#0
	jsr	cur_xorstat

; end_addr-$0200 to end_addr
	ldx	end_addr
	ldy	end_addr+1
	jsr	set_eptr
	dey
	dey
	jsr	set_ptr	
	ldx	num_cycles
	lda	key_offs
	clc
	adc	up_offs
	cmp	key_len
	bcc	px_skp2
;	sec			
	sbc	key_len
	dex
px_skp2:
	jsr	cur_xorstat

	jsr	find_key
	ldx	key_offs
	sta	key_buf+MAX_KEY*0,x
	jsr	find_key
	ldx	key_offs
	sta	key_buf+MAX_KEY*1,x
	jsr	find_key
	ldx	key_offs
	sta	key_buf+MAX_KEY*2,x
	cli

	lda	#"."
	jsr	$ffd2
	
	inc	key_offs
	lda	key_offs
	cmp	key_len
	bne	px_lp2

	ldx	#0
px_lp3:
	lda	key_buf,x
	sta	candidate_buf,x
	inx
	bne	px_lp3

	ldx	#<ok_msg
	ldy	#>ok_msg
	jmp	print

analyzing_msg:
	dc.b	13,"ANALYZING...",0
ok_msg:
	dc.b	"OK",13,0

;**************************************************************************
;*
;* NAME  xordecrypt, xordecrypt2
;* 
;* DESCRIPTION
;*   Decrypt binary using key
;*  
;******
xordecrypt2:
	lda	#$fe	; inc <abs>,x
	dc.b	$2c
xordecrypt:
	lda	#$2c	; bit <abs>
	sta	xd_sm1
	
	ldx	#<decrypt_msg
	ldy	#>decrypt_msg
	jsr	print

; operate on temporary key
	jsr	set_keytmp

	jsr	mem_ram

	ldx	start_addr
	ldy	start_addr+1
	jsr	set_ptr
	ldx	end_addr
	ldy	end_addr+1
	jsr	set_eptr
	ldx	#0
	ldy	#0
xd_lp2:
	lda	(ptr_zp),y
	eor	key_tmp,x
	sta	(ptr_zp),y
xd_sm1:
	inc	key_tmp,x
	inx
	cpx	tmp_len
	bne	xd_skp1
	ldx	#0
xd_skp1:
	inc	ptr_zp
	bne	xd_skp2
	inc	ptr_zp+1
xd_skp2:
	lda	ptr_zp
	cmp	eptr_zp
	lda	ptr_zp+1
	sbc	eptr_zp+1
	bcc	xd_lp2

	jsr	mem_normal

	ldx	#<done_msg
	ldy	#>done_msg
	jsr	print
	rts
decrypt_msg:
	dc.b	13,"DECODING...",0
done_msg:
	dc.b	"DONE",0

;**************************************************************************
;*
;* NAME  reduce_key
;*   
;* DESCRIPTION
;*   Reduce key by splitting in halves and comparing if same.
;*  
;******
reduce_key:
	ldx	#<reduce_msg
	ldy	#>reduce_msg
	jsr	print
; do key reduction here
rk_lp1:
	lda	key_len
	lsr
	bcs	rk_ex1		;odd length, done!
	tay
	ldx	#0
rk_lp2:
	lda	key_buf,x
	cmp	key_buf,y
	bne	rk_ex1		;mismatch, done!
	inx
	iny
	cpy	key_len
	bne	rk_lp2
	lsr	key_len		;reduce once, try one more
	bcc	rk_lp1		;always taken
rk_ex1:
	lda	key_len
	jmp	print_keylen
reduce_msg:
	dc.b	13,"REDUCING...",0


;**************************************************************************
;*
;* NAME  set_keytmp
;*   
;* DESCRIPTION
;*   Copy key to key_tmp.
;*   
;******
set_keytmp:
	ldx	#MAX_KEY
sk_lp1:
	lda	key_buf-1,x
	sta	key_tmp-1,x
	dex
	bne	sk_lp1
	lda	key_len
	sta	tmp_len
	rts

;**************************************************************************
;*
;* NAME  print_keylen, print_key, print_candidates
;*   
;* DESCRIPTION
;*   print key in buffer
;*   
;******
print_keylen:
	pha
	tax
	lda	#"N"
	jsr	$ffd2
	lda	#"="
	jsr	$ffd2
	lda	#0
	jsr	$bdcd
	jsr	print_cr
	pla
	rts

print_key:
	jsr	set_keytmp
print_keytmp:
	jsr	print_key_common2
	jmp	print_cr

print_candidates:
	ldy	#MAX_KEY*0
	jsr	print_key_common
	ldy	#MAX_KEY*1
	jsr	print_key_common
	ldy	#MAX_KEY*2
	jsr	print_key_common
	jmp	print_cr
;	rts

print_key_common:
	lda	orig_key_len
	sta	tmp_len
	ldx	#0
pk_lp1:
	lda	candidate_buf,y
	sta	key_tmp,x
	iny	
	inx
	cpx	#MAX_KEY
	bne	pk_lp1

print_key_common2:
	ldx	#<key_msg
	ldy	#>key_msg
	jsr	print

; print key as chars
	ldx	#0
pk_lp2:
	lda	key_tmp,x
	jsr	printable
	inx
	cpx	tmp_len
	bne	pk_lp2
	lda	#COL_TEXT
	sta	646
	ldx	#<key2_msg
	ldy	#>key2_msg
	jsr	print

; print key as hex
	ldx	#0
	beq	pk_skp3
pk_lp3:
	jsr	print_space
pk_skp3:
	lda	key_tmp,x
	jsr	print_hex
	inx
	cpx	tmp_len
	bne	pk_lp3
		
	lda	#")"
	jmp	$ffd2
	
key_msg:
	dc.b	13,"KEY: ",34,0
key2_msg:
	dc.b	34,13,"(",0

printable:
	cmp	#$20
	bcc	pt_unprintable
	cmp	#$80
	bcc	pt_printable
	cmp	#$a0
	bcc	pt_unprintable	
pt_printable:
	ldy	#COL_TEXTKEY
	bne	pt_print
pt_unprintable:
	ldy	#COL_UNPRINTABLE
	lda	#"."
pt_print:
	sty	646
	jmp	$ffd2
		
;**************************************************************************
;*
;* NAME  identify
;*   
;* DESCRIPTION
;*   Identify file type in buffer
;*   
;******
identify:
	lda	#<ident
	sta	iptr_zp
	lda	#>ident
	sta	iptr_zp+1

	ldy	#0
id_lp1:
	lda	iptr_zp
	sta	this_id
	lda	iptr_zp+1
	sta	this_id+1
	
	jsr	checkz_iptr
	beq	id_fl1
;skip_string
	dey
id_lp2:
	iny
	lda	(iptr_zp),y
	bne	id_lp2
	iny
; read ident chunks
	lda	(iptr_zp),y
	sta	ptr_zp
	iny
	lda	(iptr_zp),y
	sta	ptr_zp+1
	iny
	lda	(iptr_zp),y	; len
	iny
	sta	len_zp
	jsr	update_iptr
	ldx	ptr_zp
	ldy	ptr_zp+1
	jsr	set_ptr
	ldy	#0
id_lp3:
	sei
	ldx	#$34
	stx	$01
	lda	(ptr_zp),y
	ldx	#$37
	stx	$01
	cli
	cmp	(iptr_zp),y
	bne	id_skp1
	iny
	cpy	len_zp
	bne	id_lp3

	lda	this_id
	sta	iptr_zp
	clc
	adc	#2
	tax
	lda	this_id+1
	sta	iptr_zp+1
	adc	#0
	tay
	jsr	print
	jsr	print_cr
	
	clc
	rts

id_skp1:	
	ldy	len_zp
	jsr	update_iptr		
	jmp	id_lp1
			
id_fl1:
	ldx	#<unknown_msg
	ldy	#>unknown_msg
	jsr	print
	sec
	rts
unknown_msg:
	dc.b	"UNKNOWN/UNSUPPORTED",13,0

checkz_iptr:
	lda	(iptr_zp),y
	iny
	ora	(iptr_zp),y
	php
	iny
	plp
	rts

update_iptr:
	tya
	clc
	adc	iptr_zp
	sta	iptr_zp
	bcc	uip_skp1
	inc	iptr_zp+1
uip_skp1:
	ldy	#0
	rts


;**************************************************************************
;*
;* NAME  process_tcd
;*   
;* DESCRIPTION
;*   Process tcd coded files
;*   
;******
process_tcd:
; fix up end
	ldx	#<$0801
	ldy	#>$0801
	jsr	set_dptr
	ldx	#<$0901
	ldy	#>$0901
	jsr	set_ptr
	ldx	end_addr
	ldy	end_addr+1
	jsr	set_eptr
	jsr	transfer
	dec	end_addr+1

	jsr	print_cr
	lda	#4
	jsr	print_keylen
	jsr	perform_xorstat

	jsr	print_key

	jsr	xordecrypt
	rts

	
;**************************************************************************
;*
;* NAME  process_oneway
;*   
;* DESCRIPTION
;*   Process oneway coded files
;*   
;******
process_oneway:
; fix up end
	ldx	#<$0801
	ldy	#>$0801
	jsr	set_dptr
	ldx	end_addr
	ldy	end_addr+1
	jsr	set_eptr
	lda	end_addr
	sec
	sbc	#$ad
	sta	end_addr
	tax
	lda	end_addr+1
	sbc	#$00
	sta	end_addr+1
	tay
	jsr	set_ptr
	jsr	transfer


	lda	#16
	jsr	perform_autocorr
;Acc=key_len
	jsr	perform_xorstat

	jsr	reduce_key		

	jsr	print_key

	jsr	xordecrypt
	rts

;**************************************************************************
;*
;* NAME  process_snacky
;*   
;* DESCRIPTION
;*   Process snacky coded files
;*   
;******
process_snacky:
; fix up end
	ldx	#<$0801
	ldy	#>$0801
	jsr	set_dptr
	ldx	#<$08b0
	ldy	#>$08b0
	jsr	set_ptr
	ldx	end_addr
	ldy	end_addr+1
	jsr	set_eptr
	jsr	transfer

	lda	end_addr
	sec
	sbc	#<[$08b0-$0801]
	sta	end_addr
	bcs	psn_skp1
	dec	end_addr+1
psn_skp1:

	lda	#17
	jsr	perform_xorstat

	ldx	#<findinglen_msg
	ldy	#>findinglen_msg
	jsr	print
	ldx	#17
psn_lp1:
	lda	key_buf-1,x	
	cmp	#$0d
	bne	psn_skp2
	dex
	bne	psn_lp1
psn_skp2:
	stx	key_len
	txa
	jsr	print_keylen
	
	jsr	print_key

	lda	orig_key_len
	sta	key_len
	jsr	xordecrypt
	rts

findinglen_msg:
	dc.b	13,"FINDING LENGTH...",0

;**************************************************************************
;*
;* NAME  process_timecoder
;*   
;* DESCRIPTION
;*   Process Timecoder V1/V2 coded files
;*   
;******
process_timecoder:

	jsr	estimate_keysum
;key_sum updated

;***
; move blocked data down to $0801 and recalculate end address.
	ldx	#<$0801
	ldy	#>$0801
	jsr	set_dptr

	lda	#0
	sta	len_zp
	ldx	key_sum
	ldy	#>$0a00
pt_lp1:
	jsr	set_ptr
	iny
	jsr	set_eptr
	jsr	transfer

; preserve checksum bytes to buffer
	ldx	len_zp
	ldy	#0
	lda	(eptr_zp),y
	sta	csum_tmp,x
	inc	len_zp
	
	inc	eptr_zp
	bne	pt_skp1
	inc	eptr_zp+1
pt_skp1:

	jsr	get_eptr

	cpx	end_addr
	tya
	sbc	end_addr+1
	bcc	pt_lp1

; len_zp = num pages, = num check sum bytes
	ldy	len_zp
; preserve checksum bytes
	dey	;one less, because the last block is not a full block
		;(usually)
	sty	csum_num
	
	ldx	#0
pt_lp2:
	lda	csum_tmp,x
	sta	csum_buf,x
	dex
	bne	pt_lp2	

;***
; recalculate end address

; end_addr-=$0Axx
	lda	end_addr
	sec
	sbc	key_sum
	sta	end_addr
	lda	end_addr+1
	sbc	#>$0a00
	sta	end_addr+1

; end_addr+=$0801
	lda	end_addr
	clc
	adc	#<$0801
	sta	end_addr
	lda	end_addr+1
	adc	#>$0801
	sta	end_addr+1

; end_addr-=len_zp
	lda	end_addr
	sec
	sbc	len_zp
	sta	end_addr
	bcs	pt_skp2
	dec	end_addr+1
pt_skp2:

; linear data now in buffer, process it.
	lda	#40
	jsr	perform_autocorr2
; Acc=Key_len
	jsr	perform_xorstat2

	jsr	test_key
	bcc	pt_skp3

	jsr	permute_probabilities

pt_skp3:
	jsr	print_key

	jsr	xordecrypt2
	
	rts

;**************************************************************************
;*
;* NAME  estimate_keysum
;*   
;* DESCRIPTION
;*   Estimate the key sum for a Timecoder encoded file by performing
;*   heuristic analysis of the $0A00-$0AFF region.
;*   
;******
estimate_keysum:
	ldx	#<keysum_msg
	ldy	#>keysum_msg
	jsr	print

	sei
; copy data to heuristics buffer
	ldx	#<$0a00
	ldy	#>$0a00
	jsr	set_ptr
	iny
	jsr	set_eptr
	ldx	#<heur_tmp
	ldy	#>heur_tmp
	stx	dptr_zp
	sty	dptr_zp+1
	jsr	transfer

; calculate difference.  Original padding is a timer eor:ed with the
; start of the kernal rom, with screen and interrupts enabled.
	ldx	#0
eks_lp1:
	lda	heur_tmp,x
	eor	$e000,x
	sta	heur_tmp,x
	inx
	bne	eks_lp1
	dex
eks_lp2:
	lda	heur_tmp-1,x
	sec
	sbc	heur_tmp,x
	sta	heur_tmp,x	
	dex
	bne	eks_lp2

; apply heuristic scan
	lda	#ST_NORMAL
	sta	heur_state
	ldx	#1
eks_lp3:
	lda	heur_tmp,x
	clc
eks_branch	equ	.+2
heur_state	equ	.+1
	bcc	eks_st_normal
eks_scont:
	sta	heur_state
eks_cont:
	inx
	bne	eks_lp3

eks_ex1:
	cli
	jsr	print_dollar
	lda	key_sum
	jsr	print_hex
	jsr	print_cr
	rts
	
go_st_normal:
	lda	#ST_NORMAL
	bne	eks_scont	; always taken
eks_st_normal:	
ST_NORMAL	equ	eks_st_normal - eks_branch
	stx	key_sum
	cmp	#$5e
	beq	go_st_badline
	cmp	#$5f
	beq	go_st_badline
	cmp	#$34
	bne	go_st_irq
	beq	eks_cont	; always taken

go_st_badline:
	lda	#ST_BADLINE
	bne	eks_scont	; always taken
eks_st_badline:	
ST_BADLINE	equ	eks_st_badline - eks_branch
	stx	key_sum
	cmp	#$34
	bne	go_st_irq
	beq	go_st_normal	; always taken

go_st_irq:
	ldy	#2
	lda	#ST_IRQ
	bne	eks_scont	; always taken
eks_st_irq:	
ST_IRQ		equ	eks_st_irq - eks_branch
	cmp	#$5e
	beq	go_st_badline
	cmp	#$5f
	beq	go_st_badline
	cmp	#$34
	beq	go_st_normal
	dey
	bne	eks_cont
	beq	eks_ex1		; always taken

keysum_msg:
	dc.b	13,"ESTIMATING KEY SUM...",0


;**************************************************************************
;*
;* NAME  permute_probabilities
;*   
;* DESCRIPTION
;*   test all combinations of the three most probably key bytes for each
;*   index.
;*   
;******
permute_probabilities:
	ldx	#<permute_msg
	ldy	#>permute_msg
	jsr	print

	ldx	#MAX_KEY-1
pp_lp1:
	txa
	sta	permute_tmp,x
	dex
	bpl	pp_lp1

	lda	key_len
	sta	tmp_len

pp_lp2:
; apply permutation and check key sum against previous estimate
	ldx	#0
	stx	tmp_zp
pp_lp3:
	ldy	permute_tmp,x
	lda	key_buf,y
	sta	key_tmp,x
	clc
	adc	tmp_zp
	sta	tmp_zp
	inx
	cpx	tmp_len
	bne	pp_lp3
	cmp	key_sum
	bne	pp_skp1		; bad key sum, skip check

	jsr	test_key_silent
	bcc	pp_ex1		; passes key check, yay, exit!

pp_skp1:
; update permutation sequence
	ldx	tmp_len
pp_lp4:
	dex
	bmi	pp_fl1
	lda	permute_tmp,x
	clc
	adc	#MAX_KEY
	sta	permute_tmp,x
	sec
	sbc	#MAX_KEY*NUM_KEYS
	bcc	pp_lp2
	sta	permute_tmp,x
	jmp	pp_lp4
pp_fl1:

	ldx	#<bad_msg
	ldy	#>bad_msg
	jsr	print
	sec
	rts

pp_ex1:

; update key with the permutated
	ldx	#0
pp_lp5:
	ldy	permute_tmp,x
	lda	key_buf,y
	sta	key_buf,x
	inx
	cpx	tmp_len
	bne	pp_lp5

	ldx	#<ok_msg
	ldy	#>ok_msg
	jsr	print
	clc
	rts

permute_msg:
	dc.b	13,"PERMUTING PROBABILITIES...",0
	
;**************************************************************************
;*
;* NAME  test_key, test_key_silent
;*   
;* DESCRIPTION
;*   Check a key in key temp against checksum bytes of a Timecoder coded 
;*   file
;*   
;******
test_key:
	ldx	#<keycheck_msg
	ldy	#>keycheck_msg
	jsr	print

	jsr	set_keytmp
	jsr	test_key_silent
	bcs	tk_fl1

	ldx	#<ok_msg
	ldy	#>ok_msg
	jsr	print
	clc
	rts
tk_fl1:
	ldx	#<bad_msg
	ldy	#>bad_msg
	jsr	print
	sec
	rts

keycheck_msg:
	dc.b	13,"VERIFYING INITIAL KEY...",0
bad_msg:
	dc.b	"BAD",13,0

test_key_silent:
	jsr	mem_ram

	lda	#0
	sta	len_zp

	ldx	start_addr
	ldy	start_addr+1
	jsr	set_ptr
	ldx	#0
	stx	tmp_zp
tks_lp1:
	ldy	#0
tks_lp2:
	lda	(ptr_zp),y
	eor	key_tmp,x
	inc	key_tmp,x		
	clc
	adc	tmp_zp
	adc	#1
	sta	tmp_zp
	inx
	cpx	tmp_len
	bne	tks_skp1
	ldx	#0
tks_skp1:
	iny
	bne	tks_lp2
	inc	ptr_zp+1
	ldy	len_zp
	lda	tmp_zp
	cmp	csum_buf,y
	bne	tks_fl1

	inc	len_zp
	lda	len_zp
	cmp	csum_num
	bne	tks_lp1
	
	jsr	mem_normal
	clc
	rts

tks_fl1:
	jsr	mem_normal
	sec
	rts

;**************************************************************************
;*
;* SECTION  data
;*   
;******

;******
; identities
ident:
;TCD Coder
	dc.w	process_tcd
	dc.b	"TCD CODER",0
	dc.w	$0850	;IDENT
	dc.b	20
	dc.b	$a5,$fb,$8d,$f0,$03,$a5,$fc,$8d,$f1,$03
	dc.b	$a5,$fd,$8d,$f2,$03,$a5,$fe,$8d,$f3,$03
;Oneway Coder
	dc.w	process_oneway
	dc.b	"ONEWAY CODER",0
	dc.w	$0876	;IDENT
	dc.b	7
	dc.b	$b1,$fb,$5d,$f0,$03,$91,$fb
;Snacky Coder
	dc.w	process_snacky
	dc.b	"SNACKY/GP CODER",0
	dc.w	$086a	;IDENT
	dc.b	8
	dc.b	$52,$83,$1e,$af,$2b,$83,$9a,$af
;Timecoder V1/V2
	dc.w	process_timecoder
	dc.b	"TRAP TIME CODER V1/V2",0
	dc.w	$09b7	;IDENT
	dc.b	10
	dc.b	$b1,$ac,$5d,$28,$02,$fe,$28,$02,$91,$fd
; end marker
	dc.w	0

end_code	equ	.

	seg.u	bss_low
;**************************************************************************
;*
;* SECTION  bss_low
;*   
;******
	org	$02a7
tmp_len:
	ds.b	1
key_tmp:
	ds.b	MAX_KEY

	org	$0340
key_buf:
	ds.b	MAX_KEY*NUM_KEYS
KEY_BUF_LEN	equ	. - key_buf

	seg	data_bss
;**************************************************************************
;*
;* SECTION  data_bss
;*   
;******
	org	end_code
; identity buffers
this_id:
	ds.w	1

; key buffers
up_offs:
	ds.b	1
num_cycles:
	ds.b	1
key_offs:
	ds.b	1
key_len:
	ds.b	1
orig_key_len:
	ds.b	1
key_sum:
	ds.b	1
maxtmp:
	ds.b	3
; autocorr temporaries
cur_n:
	ds.b	1
; autocorr buffers
max_n:
	ds.b	1
auto_cnt:
	ds.b	MAX_KEY
permute_tmp	equ	auto_cnt

max_ind:
	ds.b	1


; file I/O variables
filename:
	ds.b	40
filename_end:

; program buffer variables
start_addr:	
	ds.w	1
end_addr:	
	ds.w	1
offset:
	ds.w	1
	
	ALIGN2	"stats",256

;**************************************************************************
;*
;* SECTION  statistics data
;*   
;******
stats0:
	dc.b	$52,$ab,$de,$87,$97,$63,$c3,$c5,$e3,$13,$d4,$d2,$17,$6f,$c6,$e2
	dc.b	$32,$15,$96,$ae,$c3,$c2,$d5,$f6,$3d,$0b,$75,$ed,$bb,$19,$e4,$94
	dc.b	$98,$a1,$4f,$02,$9f,$bc,$e6,$54,$0b,$64,$df,$1a,$90,$6a,$3d,$e4
	dc.b	$16,$2d,$69,$8a,$9b,$74,$ed,$75,$c1,$94,$d6,$f0,$a2,$12,$53,$be
	dc.b	$eb,$80,$6f,$77,$93,$29,$fe,$0b,$fe,$88,$36,$1c,$38,$33,$8f,$e9
	dc.b	$7e,$3b,$e5,$b6,$b4,$fc,$40,$40,$44,$81,$24,$eb,$3b,$5d,$e4,$8a
	dc.b	$a0,$a5,$c0,$1e,$db,$b7,$cc,$fe,$f1,$ca,$fd,$d1,$f1,$f7,$5b,$d8
	dc.b	$d0,$6e,$17,$e7,$86,$f0,$b6,$08,$dc,$3b,$1d,$01,$1f,$93,$81,$36
	dc.b	$ed,$24,$2d,$7d,$9f,$c6,$17,$38,$b7,$a1,$3d,$5a,$e8,$a5,$62,$61
	dc.b	$1d,$96,$eb,$58,$09,$0b,$e7,$e0,$2b,$d2,$8b,$af,$68,$9b,$00,$48
	dc.b	$4e,$9a,$89,$15,$91,$4b,$94,$de,$56,$1c,$4a,$42,$82,$cd,$31,$3f
	dc.b	$56,$74,$fc,$81,$2c,$5c,$d9,$e6,$f5,$56,$c5,$ff,$cf,$d7,$b6,$01
	dc.b	$cb,$d5,$83,$e5,$1b,$ae,$a9,$94,$c4,$8f,$48,$68,$75,$e2,$de,$3c
	dc.b	$5c,$e4,$04,$1f,$95,$a0,$8d,$26,$b3,$08,$a9,$9a,$a5,$e1,$20,$d6
	dc.b	$ae,$b1,$df,$3d,$54,$62,$8a,$a2,$6f,$96,$6b,$bf,$74,$c2,$4d,$41
	dc.b	$cd,$e6,$ce,$0b,$2d,$25,$32,$f1,$71,$4d,$ec,$c3,$01,$9a,$e7,$e5
stats1:
	dc.b	$4b,$28,$16,$26,$12,$11,$0f,$14,$1d,$0e,$0b,$07,$0b,$09,$09,$0a
	dc.b	$10,$08,$08,$07,$09,$06,$05,$04,$0f,$05,$04,$03,$04,$04,$04,$04
	dc.b	$4a,$07,$09,$04,$05,$03,$05,$04,$07,$07,$07,$03,$08,$0b,$09,$05
	dc.b	$10,$09,$09,$05,$0e,$05,$05,$06,$09,$05,$05,$02,$05,$03,$03,$04
	dc.b	$08,$08,$05,$06,$05,$08,$03,$04,$07,$06,$04,$03,$11,$04,$05,$05
	dc.b	$06,$03,$05,$05,$06,$05,$03,$03,$06,$03,$03,$01,$03,$02,$01,$02
	dc.b	$0f,$02,$02,$02,$02,$05,$02,$01,$04,$08,$01,$01,$02,$01,$02,$01
	dc.b	$03,$02,$02,$01,$02,$01,$01,$04,$06,$02,$02,$02,$03,$02,$02,$04
	dc.b	$09,$08,$05,$04,$07,$21,$07,$03,$08,$03,$04,$05,$05,$0f,$05,$03
	dc.b	$08,$06,$02,$03,$03,$03,$02,$02,$04,$08,$04,$01,$02,$09,$05,$02
	dc.b	$0e,$02,$10,$03,$07,$14,$06,$06,$0a,$1d,$0a,$03,$03,$06,$05,$04
	dc.b	$09,$09,$02,$02,$02,$02,$01,$01,$02,$07,$02,$01,$03,$08,$02,$03
	dc.b	$09,$03,$03,$03,$05,$04,$0f,$03,$08,$0b,$08,$02,$03,$02,$06,$03
	dc.b	$2e,$01,$03,$02,$03,$02,$02,$02,$03,$03,$02,$01,$02,$04,$02,$02
	dc.b	$07,$02,$02,$03,$03,$05,$0a,$03,$0a,$03,$06,$02,$03,$04,$08,$03
	dc.b	$12,$03,$03,$03,$04,$04,$03,$0b,$0b,$05,$06,$07,$0b,$08,$0a,$1a

;**************************************************************************
;*
;* SECTION  statistics buffers
;*   
;******
statbuf0:
	ds.b	256
statbuf1:
	ds.b	256
statbuf2:
	ds.b	256
heur_tmp	equ	statbuf0
csum_tmp	equ	statbuf1	
candidate_buf	equ	statbuf2
	
csum_buf	equ	$fe00
csum_num	equ	$ff00
	align	256	
; program buffer
program_buffer:
	echo	"program_buffer:",program_buffer,"-",$10000, " ", [$10000-program_buffer]/254,"blocks."
; eof
